//+------------------------------------------------------------------+
//|                                                       Levels.mq4 |
//+------------------------------------------------------------------+
#property strict
#property indicator_chart_window

enum Bias {
Bullish=2, //Bullish
Bearish=3, //Bearish 
};
input Bias Mybias=2; //My Bias

extern ENUM_TIMEFRAMES  TimePeriod=PERIOD_CURRENT;

int init(){
   return(INIT_SUCCEEDED);
   }

int deinit(){
   ObjectsDeleteAll();
   return(0);
   }

int OnCalculate(const int rates_total,
                const int prev_calculated,
                const datetime &time[],
                const double &open[],
                const double &high[],
                const double &low[],
                const double &close[],
                const long &tick_volume[],
                const long &volume[],
                const int &spread[])
  {
   return(rates_total);
  }

void OnChartEvent(const int id,
                  const long &lparam,
                  const double &dparam,
                  const string &sparam)
  { 
string Bulllvls[13]={"BLRev4","BLRev3","BLRev2","BLRev1","BLAnchor","BLRet3","BLRet2","BLRet1","BLBaseline","BLExt1","BLExt2","BLExt3","BLExt4"}; //Bullish Price levels
string Bearlvls[13]={"BrRev4","BrRev3","BrRev2","BrRev1","BrAnchor","BrRet3","BrRet2","BrRet1","BrBaseline","BrExt1","BrExt2","BrExt3","BrExt4"}; //Bearish Price levels

const double Rlvls[13]={-2,-1.75,-1.5,-1.25,-1,-0.75,-0.5,-0.25,0,0.25,0.5,0.75,1};       //Ratio Levels
double high, low, close, Time1, Time2, BLwidth, Brwidth;

int ts=14400;
switch(TimePeriod){
   case(43200):ts=2520000;break;   
   case(10080):ts=512000; break;
   case(1440):ts=86480;break;
   case(240):ts=14400;break;
   case(60):ts=3600;break;
   case(30):ts=1800;break;
   case(15):ts=900;break;
   case(5):ts=300;break;
   case(1):ts=60;break;
   }
        Time1 = iTime(NULL, TimePeriod,0);
        Time2 = Time1+ts;        //this is the presumed end-time of the period, offset
        high  = iHigh(NULL,TimePeriod,1);
        low   = iLow(NULL,TimePeriod,1);
        close = iClose(NULL,TimePeriod,1);
        BLwidth=close-low;
        Brwidth=high-close;

if(Mybias!=3){
  for(int iObj=ObjectsTotal()-1; iObj >= 0; iObj--){
        string BLout = ObjectName(iObj);
        if (StringFind(BLout, "Br") == 0)  ObjectDelete(BLout);}
        
  for(int i=0; i<=13; i++){
    double st= close+Rlvls[i]*BLwidth; //st is the starting price
    double ep= high+Rlvls[i]*BLwidth; //ep is the ending price
    ObjectCreate(NULL,Bulllvls[i],OBJ_TREND,0,Time1,st,Time2,ep);
    ObjectSetInteger(NULL,Bulllvls[i],OBJPROP_COLOR,clrDarkGreen);
    ObjectSetInteger(NULL,Bulllvls[i],OBJPROP_STYLE,STYLE_DASH);
    ObjectSetInteger(NULL,Bulllvls[i],OBJPROP_WIDTH,1);
    ObjectSetInteger(NULL,Bulllvls[i],OBJPROP_SELECTABLE,true);
    ObjectSetInteger(NULL,Bulllvls[i],OBJPROP_SELECTED,false);
    ObjectSetInteger(NULL,Bulllvls[i],OBJPROP_RAY,false);
    ObjectSetInteger(NULL,Bulllvls[i],OBJPROP_HIDDEN,false);
    ObjectSetInteger(NULL,"BLAnchor",OBJPROP_WIDTH,3);
    ObjectSetInteger(NULL,"BLBaseline",OBJPROP_WIDTH,3);}
   }
//==================================================================
else{
   for(int iObj=ObjectsTotal()-1; iObj >= 0; iObj--){
        string Brout = ObjectName(iObj);
        if (StringFind(Brout, "BL") == 0)  ObjectDelete(Brout);}   
   
   for(int i=0; i<=13; i++){
    double st= close-Rlvls[i]*Brwidth;
    double ep= low-Rlvls[i]*Brwidth;
    ObjectCreate(NULL,Bearlvls[i],OBJ_TREND,0,Time1,st,Time2,ep);
    ObjectSetInteger(NULL,Bearlvls[i],OBJPROP_COLOR,clrDarkBlue);
    ObjectSetInteger(NULL,Bearlvls[i],OBJPROP_STYLE,STYLE_DASH);
    ObjectSetInteger(NULL,Bearlvls[i],OBJPROP_WIDTH,1);
    ObjectSetInteger(NULL,Bearlvls[i],OBJPROP_SELECTABLE,true);
    ObjectSetInteger(NULL,Bearlvls[i],OBJPROP_SELECTED,false);
    ObjectSetInteger(NULL,Bearlvls[i],OBJPROP_RAY,false);
    ObjectSetInteger(NULL,Bearlvls[i],OBJPROP_HIDDEN,false);
    ObjectSetInteger(NULL,"BrAnchor",OBJPROP_WIDTH,3);
    ObjectSetInteger(NULL,"BrBaseline",OBJPROP_WIDTH,3);}
  }}//closing OnChartEvent()